/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables.records;


import be.lghs.accounting.model.tables.Accounts;

import java.math.BigDecimal;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class AccountsRecord extends UpdatableRecordImpl<AccountsRecord> implements Record4<UUID, String, String, BigDecimal> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>accounting.accounts.id</code>.
     */
    public void setId(UUID value) {
        set(0, value);
    }

    /**
     * Getter for <code>accounting.accounts.id</code>.
     */
    public UUID getId() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>accounting.accounts.name</code>.
     */
    public void setName(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>accounting.accounts.name</code>.
     */
    public String getName() {
        return (String) get(1);
    }

    /**
     * Setter for <code>accounting.accounts.description</code>.
     */
    public void setDescription(String value) {
        set(2, value);
    }

    /**
     * Getter for <code>accounting.accounts.description</code>.
     */
    public String getDescription() {
        return (String) get(2);
    }

    /**
     * Setter for <code>accounting.accounts.current_balance</code>.
     */
    public void setCurrentBalance(BigDecimal value) {
        set(3, value);
    }

    /**
     * Getter for <code>accounting.accounts.current_balance</code>.
     */
    public BigDecimal getCurrentBalance() {
        return (BigDecimal) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row4<UUID, String, String, BigDecimal> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    @Override
    public Row4<UUID, String, String, BigDecimal> valuesRow() {
        return (Row4) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return Accounts.ACCOUNTS.ID;
    }

    @Override
    public Field<String> field2() {
        return Accounts.ACCOUNTS.NAME;
    }

    @Override
    public Field<String> field3() {
        return Accounts.ACCOUNTS.DESCRIPTION;
    }

    @Override
    public Field<BigDecimal> field4() {
        return Accounts.ACCOUNTS.CURRENT_BALANCE;
    }

    @Override
    public UUID component1() {
        return getId();
    }

    @Override
    public String component2() {
        return getName();
    }

    @Override
    public String component3() {
        return getDescription();
    }

    @Override
    public BigDecimal component4() {
        return getCurrentBalance();
    }

    @Override
    public UUID value1() {
        return getId();
    }

    @Override
    public String value2() {
        return getName();
    }

    @Override
    public String value3() {
        return getDescription();
    }

    @Override
    public BigDecimal value4() {
        return getCurrentBalance();
    }

    @Override
    public AccountsRecord value1(UUID value) {
        setId(value);
        return this;
    }

    @Override
    public AccountsRecord value2(String value) {
        setName(value);
        return this;
    }

    @Override
    public AccountsRecord value3(String value) {
        setDescription(value);
        return this;
    }

    @Override
    public AccountsRecord value4(BigDecimal value) {
        setCurrentBalance(value);
        return this;
    }

    @Override
    public AccountsRecord values(UUID value1, String value2, String value3, BigDecimal value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached AccountsRecord
     */
    public AccountsRecord() {
        super(Accounts.ACCOUNTS);
    }

    /**
     * Create a detached, initialised AccountsRecord
     */
    public AccountsRecord(UUID id, String name, String description, BigDecimal currentBalance) {
        super(Accounts.ACCOUNTS);

        setId(id);
        setName(name);
        setDescription(description);
        setCurrentBalance(currentBalance);
    }
}
